<template>
  <div class="p-5">
    <el-form
      :label-position="'top'"
      :model="bankTransferWithdrawalFormData"
      :rules="bankTransferWithdrawalRules"
      ref="bankTransferWithdrawalFormRef"
      :validate-on-rule-change="false"
    >
      <div
        v-if="bankTransferWithdrawalTextInfo?.Text.length > 0"
        class="p-4 mb-4 text-sm rounded bg-background5 font-normal --text4"
        v-html="bankTransferWithdrawalTextInfo?.Text"
      ></div>
      <ui-radio-group
        v-model="selectedBank"
        class="flex flex-wrap select-bank py-2 depsit-select-bank"
        group-name="select-company-bank-name"
      >
        <ui-radio-button
          v-for="bank in bankRadios"
          :key="bank.PlayerBankName"
          :label="bank.PlayerBankName"
          :value="bank.Id"
          active-class="selected"
        >
          <ui-check-button
            v-if="!bank.BankLogo || bank.BankLogo == undefined"
            variant="ICON_AND_TEXT"
            :text="bank.PlayerBankName"
          />
          <ui-check-button
            v-else
            class="min-h-[3rem]"
            :img="getImagePathBankLogo(bank.BankLogo)"
            style="--height: 3rem"
          />
        </ui-radio-button>
      </ui-radio-group>
      <el-form-item
        :label="$t('bank_name')"
        prop="customizeBankName"
        v-if="isBankNameEnabled || selectedBank === 'Other'"
      >
        <el-input
          v-un-focus
          v-model="bankTransferWithdrawalFormData.customizeBankName"
        />
      </el-form-item>
      <el-form-item
        :label="$t('BranchName')"
        prop="branchName"
        v-show="branchNameSetting"
      >
        <el-input
          v-un-focus
          v-model="bankTransferWithdrawalFormData.branchName"
        />
      </el-form-item>
      <el-form-item :label="$t('bank_account_name')" prop="bankAccountName">
        <el-input
          v-un-focus
          v-model="bankTransferWithdrawalFormData.bankAccountName"
          :disabled="!isFirstTimeDeposit && selectedBank !== 'Other'"
        />
      </el-form-item>
      <el-form-item :label="$t('bank_account_number')" prop="bankAccountNumber">
        <el-input
          v-un-focus
          v-model="bankTransferWithdrawalFormData.bankAccountNumber"
          :disabled="!isFirstTimeDeposit && selectedBank !== 'Other'"
          oninput="this.value = this.value.replace(/[^0-9]/g, '')"
        />
      </el-form-item>
      <el-form-item
          v-show="cpfNumberSetting"
          :label="$t('CPF Number')"
          prop="cpfNumber"
        >
        <el-input 
          maxlength="11" 
          v-model="bankTransferWithdrawalFormData.cpfNumber" id="withdrawalCPFNumber" 
          @input="onInputValue($event, bankTransferWithdrawalFormData, 'cpfNumber')"
        />
      </el-form-item>
      <el-form-item :label="$t('balance')">
        {{ playerCreditBalance }}
      </el-form-item>
      <template v-if="isWithdrawalLimitEnabled">
        <el-form-item v-if="isAllowEligibleWithdrawal" :label="$t('eligible_withdrawal')">
          <div class="fc-primary font-bold">{{ eligibleWithdrawal }}</div>
        </el-form-item>
        <el-form-item prop="withdrawalLimit" :label="$t('remaining_rollover')">
          {{ remainingRollover }}
        </el-form-item>
      </template>
      <el-form-item :label="$t('amount')" prop="amountValue">
        <el-input
          v-un-focus
          v-model="bankTransferWithdrawalFormData.amountValue"
          oninput="this.value = this.value.replace(/[^.0-9]/g, '')"
          :placeholder="amountPlaceholder"
        >
          <template #append v-if="checkedCurrency">
            <span>000</span>
          </template>
        </el-input>
        <span v-if="checkedCurrency" class="order-1 text-xs fc-hint mt-3">{{
          $t(
            `withdrawal_amount_shown_by_the_system_${profile.Currency.toLowerCase()}`
          )
        }}</span>
      </el-form-item>
      <el-form-item
        :label="$t('payment_password')"
        v-if="isPaymentPasswordEnable"
        prop="paymentPasswordValue"
      >
        <el-input
          v-un-focus
          v-model="bankTransferWithdrawalFormData.paymentPasswordValue"
          type="password"
        />
      </el-form-item>
    </el-form>
    <div class="text-center mt-10">
      <el-button
        type="primary"
        v-on:click="submitWithdrawalBankTransfer(bankTransferWithdrawalFormRef)"
        :disabled="isWithdrawProcessing"
        round
      >
        {{ $t("submit") }}
      </el-button>
    </div>
  </div>
</template>
<script lang="ts">
import { defineComponent, PropType, toRefs } from "vue";
import { IGetTransactionBankListResponse } from "@/models/getTransactionBankListResponse";
import { IGetPaymentGatewayBanksResponse } from "@/models/getPaymentGatewayBanksRespone";
import { ProfileDto } from "@/models/getProfileResponse";
import { useNormalBankTransferWithdrawal } from "@/composables/payment/withdrawal/useNormalBankTransferWithdrawal";

export default defineComponent({
  name: "MobileNormalBankTransferWithdrawal",
  props: {
    normalBanks: {
      type: Object as PropType<IGetTransactionBankListResponse>,
      required: true,
    },
    paymentBanks: {
      type: Object as PropType<IGetPaymentGatewayBanksResponse>,
      required: true,
    },
    profile: {
      type: Object as PropType<ProfileDto>,
      required: true,
    },
    isPaymentPasswordEnable: {
      type: Boolean,
      default: false,
    },
    isWithdrawalLimitEnabled: {
      type: Boolean,
      default: false,
    },
  },
  setup(props) {
    const {
      normalBanks,
      paymentBanks,
      profile,
      isPaymentPasswordEnable,
      isWithdrawalLimitEnabled,
    } = toRefs(props);
    const {
      isFirstTimeDeposit,
      playerCreditBalance,
      withdrawalMin,
      withdrawalMax,
      bankRadios,
      selectedBank,
      branchNameSetting,
      isBankNameEnabled,
      submitWithdrawalBankTransfer,
      bankTransferWithdrawalFormRef,
      bankTransferWithdrawalFormData,
      bankTransferWithdrawalRules,
      isWithdrawProcessing,
      checkedCurrency,
      remainingRollover,
      eligibleWithdrawal,
      amountPlaceholder,
      bankTransferWithdrawalTextInfo,
      cpfNumberSetting,
    } = useNormalBankTransferWithdrawal(
      normalBanks,
      paymentBanks,
      profile,
      isPaymentPasswordEnable,
      isWithdrawalLimitEnabled
    );
    const { onChangeSelect, onVisibleChange, allowCompany, isAllowEligibleWithdrawal } = commonHelper;
    const { getImagePathBankLogo } = depositBankImageHelper;
    return {
      isFirstTimeDeposit,
      playerCreditBalance,
      withdrawalMin,
      withdrawalMax,
      bankRadios,
      selectedBank,
      branchNameSetting,
      isBankNameEnabled,
      submitWithdrawalBankTransfer,
      bankTransferWithdrawalFormRef,
      bankTransferWithdrawalFormData,
      bankTransferWithdrawalRules,
      isWithdrawProcessing,
      checkedCurrency,
      remainingRollover,
      eligibleWithdrawal,
      amountPlaceholder,
      bankTransferWithdrawalTextInfo,
      onChangeSelect,
      onVisibleChange,
      getImagePathBankLogo,
      allowCompany,
      cpfNumberSetting,
      isAllowEligibleWithdrawal,
    };
  },
});
</script>
<style scoped>
:deep(.ui-radio-group) {
  gap: 8px;
}
:deep(.ui-radio-group .check-btn__img img) {
  max-height: 32px;
}
:deep(.ui-radio-group .check-btn__img) {
  max-width: max-content;
}
:deep(.ui-radio-button .check-btn__content) {
  padding-right: 16px;
}
:deep(.ui-radio-button.selected .check-btn__content) {
  padding-right: 40px;
}
</style>
